/* 
 * PDFlib PLOP:
 * Encrypt file with certificate security.
 */

import java.io.*;
import com.pdflib.plop;
import com.pdflib.PLOPException;

public class certsec
{
    public static void main (String argv[])
    {
	plop plop = null;

        /* This is where input files live. Adjust as necessary. */
        String searchpath = "../data";

        /* Recipient certificates and permissions */

        String[][] recipients = {
            /* no permission restrictions */
            { "../data/demo_recipient_1.pem", "" },

            /* form filling and signing permissions granted, but not others */
            { "../data/demo_recipient_2.pem", "nomodify nocopy noannots noassemble" },
            { "../data/demo_recipient_3.pem", "nomodify nocopy noannots noassemble" },
        };

	try {
	    int doc;
            int r;
	    String optlist;

            if (argv.length < 2) {
                throw new Exception("usage: certsec  <infile> <outfile>");
            }

	    plop = new plop();

	    /* open unprotected input file without any password */
	    optlist = "searchpath {" + searchpath + "} ";
	    plop.set_option(optlist);

            /* open unprotected input file */
	    if ((doc = plop.open_document(argv[0], "")) == -1) {
		throw new Exception("Error: " + plop.get_errmsg());
	    }

            for (r = 0; r < recipients.length; r++) {
                optlist = "certificate={filename={" + recipients[r][0] +
                          "}} permissions={" + recipients[r][1] + "}";

                if (plop.add_recipient(optlist) == -1) {
                    /* emit warning and continue */
                    System.err.println("Warning: " + plop.get_errmsg());
                }
            }

            /* create protected output file */
            optlist = "input=" + doc;
	    if (plop.create_document(argv[1], optlist) == -1) {
	        throw new Exception("Error: "+ plop.get_errmsg());
	    }

	    /* close input and output files */
	    plop.close_document(doc, "");
        } catch (PLOPException e) {
            System.err.println("PLOP exception occurred in certsec sample:");
            System.err.println("[" + e.get_errnum() + "] " + e.get_apiname() +
                            ": " + e.get_errmsg());
        } catch (Exception e) {
            System.err.println(e);
	} finally {
	    /* delete the PLOP object */
	    if (plop != null) plop.delete();
	}
    }
}

